// Quick Chat 3.20 - core
var quick_chat_undefined;
var quick_chat_users_interval;
var quick_chat_smile = quick_chat_l10n_after.quick_chat_smile_array;
var quick_chat_data = quick_chat_l10n_after.quick_chat_data_array;
var quick_chat_last_timestamp =  0;
var quick_chat_rooms = new Array();

var quick_chat_private_queue = new Object();
var quick_chat_private_current = new Object();
var quick_chat_private_count = 0;

var quick_chat_audio_support = 0;
var quick_chat_play_audio = 0;
var quick_chat_audio_element = document.createElement('audio');
if(quick_chat_audio_element.canPlayType){
    if(quick_chat_audio_element.canPlayType('audio/ogg; codecs="vorbis"')) {
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.ogg");
        quick_chat_audio_element.setAttribute('preload', 'auto');
        quick_chat_audio_support = 1;
    } else if(quick_chat_audio_element.canPlayType('audio/mpeg;')){
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.mp3");
        quick_chat_audio_element.setAttribute('preload', 'auto');
        quick_chat_audio_support = 1;
    } else if(quick_chat_audio_element.canPlayType('audio/wav; codecs="1"')){
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.wav");
        quick_chat_audio_element.setAttribute('preload', 'auto');
        quick_chat_audio_support = 1;
    }
}

if(quick_chat_audio_support == 1){
    if(jQuery.cookie('quick_chat_sound_state'))
        quick_chat_play_audio = jQuery.cookie('quick_chat_sound_state');
    else
        quick_chat_play_audio = quick_chat_js_vars.quick_chat_audio_enable;
}

jQuery.quick_chat_random_string= function (length) {
    var iteration = 0;
    var string = "";
    var randomNumber;
    if(length == undefined){
        var length = 8;
    }

    while(iteration < length){
            randomNumber = (Math.floor((Math.random() * 100)) % 94) + 33;
            if ((randomNumber >=33) && (randomNumber <=47)) {continue;}
            if ((randomNumber >=58) && (randomNumber <=64)) {continue;}
            if ((randomNumber >=91) && (randomNumber <=96)) {continue;}
            if ((randomNumber >=123) && (randomNumber <=126)) {continue;}
            iteration++;
            string += String.fromCharCode(randomNumber);
    }
    return 'quick_chat_'+string;
};

jQuery.quick_chat_is_private_eq = function (private1, private2) {
    return ((private1['private_from'] == private2['private_from']) && (private1['private_to'] == private2['private_to'])
            ||
            (private1['private_to'] == private2['private_from']) && (private1['private_from'] == private2['private_to']))? true: false;
};

jQuery.quick_chat_spawn_private_chat = function (chat_id, username_him){
    var chat_data = new Object();
    chat_data['quick_chat_room_name'] = chat_id;
    chat_data['quick_chat_userlist_position'] = 'top';
    chat_data['quick_chat_scroll_enable'] = 1;
    chat_data['quick_chat_avatars'] = 1;
    quick_chat_data[chat_id] = chat_data;

    var string = '<div class="quick-chat-container quick-chat-container-private" data-chat-id="'+chat_id+'">';
        string += '<div class="quick-chat-container-private-titlebar"><div class="quick-chat-container-private-title">'+quick_chat_js_vars.quick_chat_private_title_string+' '+username_him+'</div><div class="quick-chat-container-private-close"><a href="">x</a></div></div>';
        string += '<div class="quick-chat-users-container quick-chat-users-container-top"></div>';
        string += '<div class="quick-chat-history-container" style="height: 300px;">';
        string += '</div>';
        if (quick_chat_js_vars.quick_chat_user_status == 0) string += '<div class="quick-chat-links"><div class="quick-chat-left-link quick-chat-transcript-link"><a title="'+quick_chat_js_vars.quick_chat_transcript_1_string+'" href="">'+quick_chat_js_vars.quick_chat_transcript_2_string+'</a></div></div>';
        string += '<textarea class="quick-chat-message"></textarea>';
    string += '</div>';

    jQuery('body').append(string);

    jQuery.quick_chat_get_private_position(chat_id);
}

jQuery.quick_chat_get_private_position = function(chat_id){
    var this_private_chat = jQuery('div[data-chat-id="'+chat_id+'"]');
    var right_position = this_private_chat.outerWidth(true) * quick_chat_private_count;
    quick_chat_private_count++;

    this_private_chat.css('right', right_position)
}

jQuery.quick_chat_update_private_cookie = function(cookie_name, cookie_value){
    jQuery.cookie(cookie_name, jQuery.toJSON(cookie_value), {path: quick_chat_js_vars.quick_chat_cookiepath, domain: quick_chat_js_vars.quick_chat_cookie_domain});
}

jQuery.fn.quick_chat_insert_at_caret = function (myValue) {

    return this.each(function() {

        if (document.selection) {

        this.focus();
        sel = document.selection.createRange();
        sel.text = myValue;
        this.focus();

        } else if (this.selectionStart || this.selectionStart == '0') {
            var startPos = this.selectionStart;
            var endPos = this.selectionEnd;
            var scrollTop = this.scrollTop;
            this.value = this.value.substring(0, startPos)+ myValue+ this.value.substring(endPos,this.value.length);
            this.focus();
            this.selectionStart = startPos + myValue.length;
            this.selectionEnd = startPos + myValue.length;
            this.scrollTop = scrollTop;
        } else {
            this.value += myValue;
            this.focus();
        }
    });
};

jQuery.quick_chat_preg_quote = function (str){
        var specials = new RegExp("[.*+?|()\\[\\]{}\\\\]", "g");
        return str.replace(specials, "\\$&");
};

jQuery.quick_chat_stripslashes = function (str){
        str = str.replace(/\\'/g,'\'');
        str = str.replace(/\\"/g,'"');
        str = str.replace(/\\\\/g,'\\');
        str = str.replace(/\\0/g,'\0');
        return str;
};

jQuery.quick_chat_update_rooms = function (){
    quick_chat_rooms = new Array();
    for(var chat_id in quick_chat_data){
        if(jQuery.inArray(quick_chat_data[chat_id]['quick_chat_room_name'], quick_chat_rooms) == -1)
            quick_chat_rooms.push(quick_chat_data[chat_id]['quick_chat_room_name']);
    }
};

jQuery.quick_chat_update_sound_state = function (){
    if(quick_chat_play_audio == 0){
         jQuery("div.quick-chat-sound-link a").css('text-decoration','line-through');
    } else{
         jQuery("div.quick-chat-sound-link a").css('text-decoration','none');
    }
};

jQuery.quick_chat_user_status_class = function(user_status){
    var user_status_class = '';
    if(user_status == 0){
        user_status_class = 'quick-chat-admin';
    } else if(user_status == 1){
        user_status_class = 'quick-chat-loggedin';
    } else if(user_status == 2){
        user_status_class = 'quick-chat-guest';
    }
    return user_status_class;
}

jQuery.quick_chat_is_private_allowed = function(user_status){
    if  (
        user_status == 0
        ||
        (user_status == 1 &&
        quick_chat_js_vars.quick_chat_loggedin_initiate_private == 1)
        ||
        (user_status == 2 &&
        quick_chat_js_vars.quick_chat_guests_initiate_private == 1)
        ){
            return true;
    }else{
        return false;
    }
}

jQuery.quick_chat_single_message_html = function(single_message, username, avatars, sys_mes){
    if(sys_mes == false){
        var alias = jQuery.quick_chat_stripslashes(single_message.alias);
        var status_class = jQuery.quick_chat_user_status_class(single_message.status);
    }else if(sys_mes == true){
        alias = quick_chat_js_vars.quick_chat_notice_string;
        status_class = 'quick-chat-notice';
    }

    var message_with_smile = jQuery.quick_chat_stripslashes(single_message.message);
    for (var smile in quick_chat_smile){
        var replace_string = '<div class="quick-chat-smile-message quick-chat-smile quick-chat-smile-'+quick_chat_smile[smile]+'" title="'+smile+'"></div>';
        message_with_smile = message_with_smile.replace(new RegExp(jQuery.quick_chat_preg_quote(smile), 'g'), replace_string);
    }
    var string = "<div class=\"quick-chat-history-message-alias-container "+status_class+"\"><div class=\"quick-chat-history-header\">";

    if(avatars == 1){
        string += jQuery.quick_chat_stripslashes(single_message.avatar);
    }

    string += "<div class=\"quick-chat-history-alias\">";

    if(alias == username || sys_mes == true  || quick_chat_js_vars.quick_chat_no_participation == 1){
        string += alias;
    } else{
        string += "<a href=\"\" title=\""+quick_chat_js_vars.quick_chat_reply_to_string.replace('%s', alias)+"\">"+alias+"</a>";
    }
    string += "</div>";

    string += "<div class=\"quick-chat-history-timestring\">"+single_message.timestring+"</div>";

    string += "</div><div class=\"quick-chat-history-message\">"+message_with_smile+"</div>";

    if(quick_chat_js_vars.quick_chat_bing_appid != '' || quick_chat_js_vars.quick_chat_user_status == 0) string += '<div class="quick-chat-history-links">';

    if(quick_chat_js_vars.quick_chat_bing_appid != ''){
        string += "<div class=\"quick-chat-translate-link\">";
            string += " <a style=\"text-decoration: none;\" href=\"\">"+quick_chat_js_vars.quick_chat_translate_string+"</a> ";
        string += "</div>";
    }

    if(quick_chat_js_vars.quick_chat_user_status == 0 && sys_mes == false){
        string += "<input class=\"quick-chat-to-delete-boxes\" type=\"checkbox\" name=\"quick-chat-to-delete[]\" value=\""+single_message.id+"\" />";
    }

    if(quick_chat_js_vars.quick_chat_bing_appid != '' || quick_chat_js_vars.quick_chat_user_status == 0) string += "</div>";

    string += "</div>";
    return string;
}

jQuery.quick_chat_check_username = function (chat_id, username_check, username_status_element){

    if (typeof(quick_chat_data[chat_id]['quick_chat_username_timeout']) != typeof(quick_chat_undefined))
        clearTimeout(quick_chat_data[chat_id]['quick_chat_username_timeout']);

    quick_chat_data[chat_id]['quick_chat_username_timeout'] = setTimeout(function(){
        jQuery.ajax({
            type: 'POST',
            url: quick_chat_js_vars.quick_chat_ajaxurl,
            data: {action: 'quick-chat-ajax-username-check', username_check: username_check, quick_chat_rooms: quick_chat_rooms, quick_chat_username_check_nonce: quick_chat_js_vars.quick_chat_username_check_nonce},
            cache: false,
            dataType: 'json',

            success: function(data){
                quick_chat_js_vars.quick_chat_username_check_nonce = data.quick_chat_username_check_nonce;
                if(quick_chat_js_vars.quick_chat_no_participation == 0 && data.quick_chat_no_participation == 1){
                    location.reload();
                }
                jQuery(username_status_element).html('');
                if(data.username_invalid == 1) {
                    jQuery(username_status_element).addClass('quick-chat-error');
                    jQuery(username_status_element).html(quick_chat_js_vars.quick_chat_username_invalid_string);
                }else if(data.username_bad_words == 1){
                    jQuery(username_status_element).addClass('quick-chat-error');
                    jQuery(username_status_element).html(quick_chat_js_vars.quick_chat_username_bad_words_string);
                }else if(data.username_exists == 1){
                    jQuery(username_status_element).addClass('quick-chat-error');
                    jQuery(username_status_element).html(quick_chat_js_vars.quick_chat_username_exists_string);
                } else if(data.username_blocked == 1){
                    jQuery(username_status_element).addClass('quick-chat-error');
                    jQuery(username_status_element).html(quick_chat_js_vars.quick_chat_username_blocked_string);
                }else if(data.username_exists == 0 || data.username_blocked == 0 || data.username_invalid == 0){
                    jQuery(username_status_element).html('');
                    quick_chat_js_vars.quick_chat_username = data.username;
                    jQuery('input.quick-chat-alias').val(data.username);
                }
            },
            beforeSend: function(){
                jQuery(username_status_element).html('');
                jQuery(username_status_element).removeClass('quick-chat-error');
                jQuery(username_status_element).html(quick_chat_js_vars.quick_chat_username_check_wait_string);
            },
            error: function(){

            }
        });
        quick_chat_data[chat_id]['quick_chat_username_timeout'] = quick_chat_undefined;
    }, 1500);
};

jQuery.quick_chat_update_messages = function(){
    jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl, {
        action: 'quick-chat-ajax-update-messages',
        quick_chat_last_timestamp: quick_chat_last_timestamp,
        quick_chat_rooms: quick_chat_rooms,
        quick_chat_update_messages_nonce: quick_chat_js_vars.quick_chat_update_messages_nonce},
        function(data){
            quick_chat_js_vars.quick_chat_update_messages_nonce = data.quick_chat_update_messages_nonce;
            if((quick_chat_js_vars.quick_chat_no_participation == 0 && data.quick_chat_no_participation == 1)
                ||
                (quick_chat_js_vars.quick_chat_no_participation == 1 && data.quick_chat_no_participation == 0)){
                location.reload();
            }
            if(data.quick_chat_success == 1){
                var updates = data.quick_chat_messages;
                jQuery('div.quick-chat-container').each(function(){
                    var already_notified = 0;
                    var chat_id = jQuery(this).attr('data-chat-id');
                    var room_name = quick_chat_data[chat_id]['quick_chat_room_name'];
                    var avatars = quick_chat_data[chat_id]['quick_chat_avatars'];
                    var username = quick_chat_js_vars.quick_chat_username;
                    var scroll_enable = quick_chat_data[chat_id]['quick_chat_scroll_enable'];
                    var history_container = jQuery(this).find('.quick-chat-history-container');

                    for(var i=0;typeof(updates[i])!=typeof(quick_chat_undefined);i++){
                        if(room_name == updates[i].room){
                            if(updates[i].alias != 'quick_chat'){
                                if( already_notified == 0
                                    &&
                                    quick_chat_play_audio == 1
                                    &&
                                    username != jQuery.quick_chat_stripslashes(updates[i].alias)
                                    &&
                                    quick_chat_last_timestamp != 0) {
                                    quick_chat_audio_element.play();
                                    already_notified = 1;
                                }
                                jQuery(history_container).append(jQuery.quick_chat_single_message_html(updates[i], username, avatars, false));
                            } else if(quick_chat_last_timestamp != 0){
                                var sys_mes = jQuery.parseJSON(jQuery.quick_chat_stripslashes(updates[i].message));
                                for (var mes_room_name in sys_mes){
                                    if(sys_mes[mes_room_name]['private_to'] == username){ // Receiver
                                        if(jQuery.quick_chat_is_private_allowed(updates[i].status)){
                                            quick_chat_private_queue[mes_room_name] = sys_mes[mes_room_name];
                                            jQuery.quick_chat_update_private_cookie('quick_chat_private_queue', quick_chat_private_queue);

                                            var invitation_received = jQuery.extend(true, {}, updates[i]);
                                            invitation_received.message = quick_chat_js_vars.quick_chat_invitation_received_string.replace('%s', sys_mes[mes_room_name]['private_from']);

                                            jQuery(history_container).append(jQuery.quick_chat_single_message_html(invitation_received, username, 0, true));
                                        }
                                    } else if(sys_mes[mes_room_name]['private_from'] == username){ // Sender
                                        var quick_chat_private_queue_found = false;
                                        for (var pq_room_name in quick_chat_private_queue){
                                            if(jQuery.quick_chat_is_private_eq(quick_chat_private_queue[pq_room_name], sys_mes[mes_room_name])){
                                                jQuery.quick_chat_spawn_private_chat(pq_room_name, sys_mes[mes_room_name]['private_to']);
                                                jQuery.quick_chat_update_rooms();

                                                delete quick_chat_private_queue[pq_room_name];
                                                jQuery.quick_chat_update_private_cookie('quick_chat_private_queue', quick_chat_private_queue);

                                                quick_chat_private_current[pq_room_name] = sys_mes[mes_room_name];
                                                quick_chat_private_current[pq_room_name]['you'] = username;
                                                quick_chat_private_current[pq_room_name]['him'] = sys_mes[mes_room_name]['private_to'];
                                                jQuery.quick_chat_update_private_cookie('quick_chat_private_current', quick_chat_private_current);
                                                quick_chat_private_queue_found = true;
                                            }
                                        }

                                        if(quick_chat_private_queue_found == false){
                                            if(jQuery.quick_chat_is_private_allowed(updates[i].status)){
                                                jQuery.quick_chat_spawn_private_chat(mes_room_name, sys_mes[mes_room_name]['private_to']);
                                                jQuery.quick_chat_update_rooms();

                                                quick_chat_private_current[mes_room_name] = sys_mes[mes_room_name];
                                                quick_chat_private_current[mes_room_name]['you'] = username;
                                                quick_chat_private_current[mes_room_name]['him'] = sys_mes[mes_room_name]['private_to'];
                                                jQuery.quick_chat_update_private_cookie('quick_chat_private_current', quick_chat_private_current);

                                                var invitation_sent = jQuery.extend(true, {}, updates[i]);
                                                invitation_sent.message = quick_chat_js_vars.quick_chat_invitation_sent_string.replace('%s', sys_mes[mes_room_name]['private_to']);

                                                jQuery(history_container).append(jQuery.quick_chat_single_message_html(invitation_sent, username, 0, true));
                                            }else{
                                                alert(quick_chat_js_vars.quick_chat_not_allowed_to_initiate_private_string);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }

                    if(scroll_enable == 1){
                        jQuery(history_container).animate({scrollTop: jQuery(history_container)[0].scrollHeight}, 500);
                    }
                });

                quick_chat_last_timestamp = updates[updates.length-1].unix_timestamp;
            }

            jQuery.quick_chat_update_messages();
        },
        'json'
    );
};

jQuery.quick_chat_update_users = function (){
    jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl, {
        action: 'quick-chat-ajax-update-users',
        quick_chat_rooms: quick_chat_rooms,
        quick_chat_update_users_nonce: quick_chat_js_vars.quick_chat_update_users_nonce},
        function(data){
            quick_chat_js_vars.quick_chat_update_users_nonce = data.quick_chat_update_users_nonce;
            if((quick_chat_js_vars.quick_chat_no_participation == 0 && data.quick_chat_no_participation == 1)
            ||
            (quick_chat_js_vars.quick_chat_no_participation == 1 && data.quick_chat_no_participation == 0)){
            location.reload();
            }

            var users = data.quick_chat_users;
            jQuery("div.quick-chat-container").each(function(){
                var chat_id = jQuery(this).attr('data-chat-id');
                var userlist_position = quick_chat_data[chat_id]['quick_chat_userlist_position'];
                var username = quick_chat_js_vars.quick_chat_username;
                var room_name = quick_chat_data[chat_id]['quick_chat_room_name'];
                var string = '';

                for(var i=0;typeof(users[i])!=typeof(quick_chat_undefined);i++){
                    if(room_name == users[i].room){
                        if(quick_chat_js_vars.quick_chat_user_status == 0){
                            var checked_ids = [];
                            jQuery(this).find('.quick-chat-users-container input[type=checkbox]:checked').each(function(){
                                checked_ids.push(jQuery(this).attr('data-user-id'));
                            });
                        }
                        var alias = jQuery.quick_chat_stripslashes(users[i].alias);

                        string += "<div class=\"quick-chat-single-user "+jQuery.quick_chat_user_status_class(users[i].status)+"\">";

                        if(alias == username || quick_chat_js_vars.quick_chat_no_participation == 1)
                            string += alias;
                        else{
                            if(quick_chat_js_vars.quick_chat_user_status == 0){
                                string += "<input class=\"quick-chat-to-ban-boxes\" type=\"checkbox\" name=\"quick-chat-to-ban[]\" value=\""+users[i].ip+"\" data-user-id=\""+users[i].id+"\""+((jQuery.inArray(users[i].id, checked_ids) == 0) ? " checked=\"checked\"":"")+"/>";
                            }
                            string += "<a href=\"\" title=\""+quick_chat_js_vars.quick_chat_private_with_string+" "+alias+"\">"+alias+"</a>";
                        }
                        if(userlist_position == 'top'){
                            string += ",";
                        }
                        string += "</div>";
                    }
                }
                jQuery(this).find('.quick-chat-users-container').html((userlist_position == 'top') ? string.substring(0, string.length-7): string);
            });
        },
        'json'
    );
};

jQuery.quick_chat_new_message = function (chat_id, message_text, sys_mes){
    var room_name = quick_chat_data[chat_id]['quick_chat_room_name'];

    jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl,
                {action: 'quick-chat-ajax-new-message',
                sys_mes: sys_mes,
                message: message_text,
                room: room_name,
                quick_chat_new_message_nonce: quick_chat_js_vars.quick_chat_new_message_nonce},
                function(data) {
                    quick_chat_js_vars.quick_chat_new_message_nonce = data.quick_chat_new_message_nonce;
                    if(quick_chat_js_vars.quick_chat_no_participation == 0 && data.quick_chat_no_participation == 1){
                        location.reload();
                    }
                });
};

jQuery(window).load(function(){
    if(quick_chat_js_vars.quick_chat_no_participation == 0){
        if(jQuery.cookie('quick_chat_private_queue') != null){
            quick_chat_private_queue = jQuery.parseJSON(jQuery.cookie('quick_chat_private_queue'));
        }

        if(jQuery.cookie('quick_chat_private_current') != null){
            quick_chat_private_current = jQuery.parseJSON(jQuery.cookie('quick_chat_private_current'));
        }

        for (var quick_chat_pc_room_name in quick_chat_private_current){
            jQuery.quick_chat_spawn_private_chat(quick_chat_pc_room_name, quick_chat_private_current[quick_chat_pc_room_name]['him']);
        }
    }

    jQuery.quick_chat_update_rooms();

    if(quick_chat_audio_support){
        jQuery("div.quick-chat-sound-link").css('display','block');
        jQuery.quick_chat_update_sound_state();
    }

    jQuery.quick_chat_update_users();
    quick_chat_users_interval = setInterval(function(){
        jQuery.quick_chat_update_users();
    }, quick_chat_js_vars.quick_chat_timeout_refresh_users * 1000);

    jQuery('textarea.quick-chat-message').live('keypress', function(e) {
        code = e.keyCode ? e.keyCode : e.which;
        if(code.toString() == 13) {
            e.preventDefault();

            var message_text = jQuery.trim(jQuery(this).val());
            if(message_text != ''){
                var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');
                jQuery(this).val('');
                jQuery.quick_chat_new_message(chat_id, message_text, false);
            }
        }
    });

    jQuery('input.quick-chat-send-button').bind('click', function(e) {
        e.preventDefault();

        var message_text = jQuery.trim(jQuery(this).prev().val());
        if(message_text != ''){
            var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');
            jQuery(this).prev().val('');
            jQuery.quick_chat_new_message(chat_id, message_text, false);
        }
        jQuery(this).prev().focus();
    });

    jQuery('input.quick-chat-alias').bind('keyup', 'change', function(){
        var username_check = jQuery.trim(jQuery(this).val());
        if(username_check != ''){
            var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');
            var username_status_element = jQuery(this).parents('.quick-chat-container').find('span.quick-chat-username-status');

            jQuery.quick_chat_check_username(chat_id, username_check, username_status_element);
        }
    });

    jQuery("div.quick-chat-smile").bind('click', function() {
        var input_textarea = jQuery(this).parents('.quick-chat-container').find('.quick-chat-message');
        var this_element = jQuery(this);

        jQuery(this).fadeTo(100, 0, function() {
            jQuery(input_textarea).quick_chat_insert_at_caret(jQuery(this_element).attr('title'));
            jQuery(this_element).fadeTo(100, 1);
        });
    });

    jQuery("div.quick-chat-history-alias a").live('click', function(e) {
        e.preventDefault();
        var input_textarea = jQuery(this).parents('.quick-chat-container').find('.quick-chat-message');
        var this_element = jQuery(this);

        jQuery(this).fadeTo(100, 0, function() {
            jQuery(input_textarea).quick_chat_insert_at_caret('@'+jQuery(this_element).text()+': ');
            jQuery(this_element).fadeTo(100, 1);
        });
    });

    jQuery("div.quick-chat-single-user a").live('click', function(e) {
        e.preventDefault();

        var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');
        var username = quick_chat_js_vars.quick_chat_username;
        var this_element = jQuery(this);

        jQuery(this).fadeTo(100, 0, function() {
            if (confirm(quick_chat_js_vars.quick_chat_private_confirm_string.replace('%s',jQuery(this_element).text()))){
                var sys_mes_json = '{"'+jQuery.quick_chat_random_string(12)+'":{"private_from":"'+username+'","private_to":"'+jQuery(this_element).text()+'"}}';
                jQuery.quick_chat_new_message(chat_id, sys_mes_json, true);
            }
            jQuery(this_element).fadeTo(100, 1);
        });
    });

    jQuery("div.quick-chat-container-private-close a").live('click', function(e) {
        e.preventDefault();
        var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');

        delete quick_chat_data[chat_id];

        delete quick_chat_private_current[chat_id];
        jQuery.quick_chat_update_private_cookie('quick_chat_private_current', quick_chat_private_current);
        quick_chat_private_count--;

        jQuery.quick_chat_update_rooms();

        jQuery(this).parents('.quick-chat-container').remove();
    });

    jQuery("div.quick-chat-sound-link a").bind('click', function(e) {
        e.preventDefault();
        var this_element = jQuery(this);

        jQuery(this).fadeTo(100, 0, function() {
            if(quick_chat_play_audio == 1){
                quick_chat_play_audio = 0;
            } else{
                quick_chat_play_audio = 1;
            }

            jQuery.cookie('quick_chat_sound_state', quick_chat_play_audio, {path: quick_chat_js_vars.quick_chat_cookiepath, domain: quick_chat_js_vars.quick_chat_cookie_domain});

            jQuery.quick_chat_update_sound_state();

            jQuery(this_element).fadeTo(100, 1);
        });
    });

    jQuery("div.quick-chat-scroll-link a").bind('click', function(e) {
        e.preventDefault();

        var chat_id = jQuery(this).parents('.quick-chat-container').attr('data-chat-id');
        var scroll_enable = quick_chat_data[chat_id]['quick_chat_scroll_enable'];
        var this_element = jQuery(this);

        jQuery(this).fadeTo(100, 0, function() {
            if(scroll_enable == 0){
                quick_chat_data[chat_id]['quick_chat_scroll_enable'] = 1;
                jQuery(this_element).css('text-decoration','none');
            } else{
                quick_chat_data[chat_id]['quick_chat_scroll_enable'] = 0;
                jQuery(this_element).css('text-decoration','line-through');
            }
            jQuery(this_element).fadeTo(100, 1);
        });
    });

    if(quick_chat_js_vars.quick_chat_user_status != 0){
        jQuery('textarea.quick-chat-message').bind('keyup', 'change', function() {
            var counter_element = jQuery(this).parents('.quick-chat-container').find('span.quick-chat-counter');
            var count = jQuery(this).val().length;
            var available = quick_chat_js_vars.quick_chat_message_maximum_number_chars - count;
            if(available <= 25 && available >= 0){
                    jQuery(counter_element).addClass('quick-chat-warning');
            } else {
                    jQuery(counter_element).removeClass('quick-chat-warning');
            }
            if(available < 0){
                    jQuery(counter_element).addClass('quick-chat-exceeded');
            } else {
                    jQuery(counter_element).removeClass('quick-chat-exceeded');
            }
            jQuery(counter_element).html(available);
        });
    }

    jQuery.quick_chat_update_messages();
});